/*
 * PG0
 *
 * console_view.h
 *
 * Copyright (C) 1996-2018 by Ohno Tomoaki. All rights reserved.
 *		https://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef VIEW_H
#define VIEW_H

/* Include Files */
#include <windows.h>
#include <tchar.h>
#ifdef OP_XP_STYLE
#include <uxtheme.h>
#include <vssym32.h>
#endif	// OP_XP_STYLE

#ifdef VIEW_USER_H
#include VIEW_USER_H
#endif

/* Define */
#ifndef CONSOLE_WND_CLASS
#define CONSOLE_WND_CLASS		TEXT("ConsoleViewClass")
#endif

//mۂTCY
#ifndef DEF_RESERVE
#define DEF_RESERVE
#define RESERVE_SZIE			4096
#define RESERVE_LINE			100
#endif

#define INPUT_SIZE				1024

#ifndef MSG_OFFSET
#define MSG_OFFSET				WM_APP + 100
#endif
#ifndef MSG_NOTIFY_OFFSET
#define MSG_NOTIFY_OFFSET		WM_APP + 500
#endif

//̒ǉ
#define WM_VIEW_ADDTEXT			(MSG_OFFSET + 0)
//struct _BUFFER ̎擾
#define WM_VIEW_GETBUFFERINFO	(MSG_OFFSET + 1)
//eLXgFƔwiF̐ݒ (wParam - TextColor, lParam - BackColor)
#define WM_VIEW_SETCOLOR		(MSG_OFFSET + 2)
//sԂ̐ݒ (wParam - sԂ̃hbg)
#define WM_VIEW_SETSPACING		(MSG_OFFSET + 4)
//_s̐ݒ
#define WM_VIEW_SETLINELIMIT	(MSG_OFFSET + 5)
//tHgsԕύX̔f
#define WM_VIEW_REFLECT			(MSG_OFFSET + 6)
//XN[̃bN (wPrama - 0ŃXN[ʒuŒA1ŕ\ʒuŒ)
#define WM_VIEW_SETSCROLLLOCK	(MSG_OFFSET + 8)
//̓[h
#define WM_VIEW_INITINPUTMODE	(MSG_OFFSET + 9)
//̓[hݒ
#define WM_VIEW_SETINPUTMODE	(MSG_OFFSET + 10)
//̓[h擾
#define WM_VIEW_GETINPUTMODE	(MSG_OFFSET + 11)
//͕擾
#define WM_VIEW_GETINPUTSTRING	(MSG_OFFSET + 12)

//R[h
#ifndef DEF_ORN
#define DEF_ORN
#define ORN_COLOR				0x03
#define ORN_BOLD				0x02
#define ORN_UNDERLINE			0x1F
#define ORN_REVERSE				0x16
#define ORN_ITALIC				0x14
#endif

//X^C}XN
#ifndef DEF_STYLE
#define DEF_STYLE
#define STYLE_TEXTCOLOR			1
#define STYLE_BACKCOLOR			2
#define STYLE_RETURNCOLOR		4
#define STYLE_BOLD				8
#define STYLE_UNDERLINE			16
#define STYLE_REVERSE			32
#define STYLE_ITALIC			64
#endif

/* Struct */
#ifndef DECL_CONSOLE_BUFFER
#define DECL_CONSOLE_BUFFER
typedef struct _VIEW_BUFFER {
	//ێĂe
	TCHAR *buf;
	//X^C (buf ̕ʒuƑΉ)
	char *style;
	//F (buf ̕ʒuƑΉ)
	char *color;
	//buf ̊mۂĂTCY
	int size;
	//buf '\0'܂ł̒
	int len;

	//Lbg̈ʒu (buf)
	TCHAR *cp;
	//IJnʒu (buf)
	TCHAR *sp;
	//㉺ړ̃LbgXW
	int cpx;

	//\s̃ItZbg (buf + line[3] 4sڂ̈ʒu)
	int *line;
	//\s̒
	int *linelen;
	//line ̊mۂĂTCY
	int linesize;
	//s (\s)
	int view_line;
	//s (_s)
	int logic_line;
	//EBhE̕
	int width;

	//XN[ o[̂܂݂݂̌̈ʒu
	int pos;
	//XN[ o[݂̌̂܂݂̈ʒu̍ől
	int max;
	//XN[̃bN (0-XN[o[̈ʒuŌŒA1-\ʒuŌŒ)
	int sc_lock;

	//ő啶
	int Limit;
	//ős
	int LineLimit;
	//^uXgbv
	int TabStop;
	//}[W
	int LeftMargin;
	//E}[W
	int RightMargin;
	//s
	int Spacing;

	//`p
	HDC mdc;
	HBITMAP hBmp;
	HBITMAP hRetBmp;

	//tHg
	LOGFONT lf;
	//tHg̍
	int FontHeight;
	//1̃tHg̕
	int CharWidth;
	//Œsb` - TRUE, σsb` - FALSE
	BOOL Fixed;

	//eLXg̐F
	COLORREF TextColor;
	//wiF
	COLORREF BackClolor;
	//wiF̃uV
	HBRUSH hBkBrush;

	//}EXtO
	BOOL mousedown;

	// ̓[h
	BOOL input_mode;
	TCHAR input_string[INPUT_SIZE + 1];
	TCHAR input_buf[INPUT_SIZE + 1];

#ifdef OP_XP_STYLE
	// XP
	HMODULE hModThemes;
	HTHEME hTheme;
#endif	// OP_XP_STYLE

	//[U
	long param1;
	long param2;
} VIEW_BUFFER;
#endif

/* Function Prototypes */
BOOL RegisterConsoleWindow(HINSTANCE hInstance);

#endif
/* End of source */
